// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package lambda

import (
	"github.com/aws/aws-sdk-go/private/protocol"
)

const (

	// ErrCodeCodeStorageExceededException for service response error code
	// "CodeStorageExceededException".
	//
	// You have exceeded your maximum total code size per account. Learn more (https://docs.aws.amazon.com/lambda/latest/dg/limits.html)
	ErrCodeCodeStorageExceededException = "CodeStorageExceededException"

	// ErrCodeEC2AccessDeniedException for service response error code
	// "EC2AccessDeniedException".
	//
	// Need additional permissions to configure VPC settings.
	ErrCodeEC2AccessDeniedException = "EC2AccessDeniedException"

	// ErrCodeEC2ThrottledException for service response error code
	// "EC2ThrottledException".
	//
	// AWS Lambda was throttled by Amazon EC2 during Lambda function initialization
	// using the execution role provided for the Lambda function.
	ErrCodeEC2ThrottledException = "EC2ThrottledException"

	// ErrCodeEC2UnexpectedException for service response error code
	// "EC2UnexpectedException".
	//
	// AWS Lambda received an unexpected EC2 client exception while setting up for
	// the Lambda function.
	ErrCodeEC2UnexpectedException = "EC2UnexpectedException"

	// ErrCodeEFSIOException for service response error code
	// "EFSIOException".
	//
	// An error occured when reading from or writing to a connected file system.
	ErrCodeEFSIOException = "EFSIOException"

	// ErrCodeEFSMountConnectivityException for service response error code
	// "EFSMountConnectivityException".
	//
	// The function couldn't make a network connection to the configured file system.
	ErrCodeEFSMountConnectivityException = "EFSMountConnectivityException"

	// ErrCodeEFSMountFailureException for service response error code
	// "EFSMountFailureException".
	//
	// The function couldn't mount the configured file system due to a permission
	// or configuration issue.
	ErrCodeEFSMountFailureException = "EFSMountFailureException"

	// ErrCodeEFSMountTimeoutException for service response error code
	// "EFSMountTimeoutException".
	//
	// The function was able to make a network connection to the configured file
	// system, but the mount operation timed out.
	ErrCodeEFSMountTimeoutException = "EFSMountTimeoutException"

	// ErrCodeENILimitReachedException for service response error code
	// "ENILimitReachedException".
	//
	// AWS Lambda was not able to create an elastic network interface in the VPC,
	// specified as part of Lambda function configuration, because the limit for
	// network interfaces has been reached.
	ErrCodeENILimitReachedException = "ENILimitReachedException"

	// ErrCodeInvalidParameterValueException for service response error code
	// "InvalidParameterValueException".
	//
	// One of the parameters in the request is invalid.
	ErrCodeInvalidParameterValueException = "InvalidParameterValueException"

	// ErrCodeInvalidRequestContentException for service response error code
	// "InvalidRequestContentException".
	//
	// The request body could not be parsed as JSON.
	ErrCodeInvalidRequestContentException = "InvalidRequestContentException"

	// ErrCodeInvalidRuntimeException for service response error code
	// "InvalidRuntimeException".
	//
	// The runtime or runtime version specified is not supported.
	ErrCodeInvalidRuntimeException = "InvalidRuntimeException"

	// ErrCodeInvalidSecurityGroupIDException for service response error code
	// "InvalidSecurityGroupIDException".
	//
	// The Security Group ID provided in the Lambda function VPC configuration is
	// invalid.
	ErrCodeInvalidSecurityGroupIDException = "InvalidSecurityGroupIDException"

	// ErrCodeInvalidSubnetIDException for service response error code
	// "InvalidSubnetIDException".
	//
	// The Subnet ID provided in the Lambda function VPC configuration is invalid.
	ErrCodeInvalidSubnetIDException = "InvalidSubnetIDException"

	// ErrCodeInvalidZipFileException for service response error code
	// "InvalidZipFileException".
	//
	// AWS Lambda could not unzip the deployment package.
	ErrCodeInvalidZipFileException = "InvalidZipFileException"

	// ErrCodeKMSAccessDeniedException for service response error code
	// "KMSAccessDeniedException".
	//
	// Lambda was unable to decrypt the environment variables because KMS access
	// was denied. Check the Lambda function's KMS permissions.
	ErrCodeKMSAccessDeniedException = "KMSAccessDeniedException"

	// ErrCodeKMSDisabledException for service response error code
	// "KMSDisabledException".
	//
	// Lambda was unable to decrypt the environment variables because the KMS key
	// used is disabled. Check the Lambda function's KMS key settings.
	ErrCodeKMSDisabledException = "KMSDisabledException"

	// ErrCodeKMSInvalidStateException for service response error code
	// "KMSInvalidStateException".
	//
	// Lambda was unable to decrypt the environment variables because the KMS key
	// used is in an invalid state for Decrypt. Check the function's KMS key settings.
	ErrCodeKMSInvalidStateException = "KMSInvalidStateException"

	// ErrCodeKMSNotFoundException for service response error code
	// "KMSNotFoundException".
	//
	// Lambda was unable to decrypt the environment variables because the KMS key
	// was not found. Check the function's KMS key settings.
	ErrCodeKMSNotFoundException = "KMSNotFoundException"

	// ErrCodePolicyLengthExceededException for service response error code
	// "PolicyLengthExceededException".
	//
	// The permissions policy for the resource is too large. Learn more (https://docs.aws.amazon.com/lambda/latest/dg/limits.html)
	ErrCodePolicyLengthExceededException = "PolicyLengthExceededException"

	// ErrCodePreconditionFailedException for service response error code
	// "PreconditionFailedException".
	//
	// The RevisionId provided does not match the latest RevisionId for the Lambda
	// function or alias. Call the GetFunction or the GetAlias API to retrieve the
	// latest RevisionId for your resource.
	ErrCodePreconditionFailedException = "PreconditionFailedException"

	// ErrCodeProvisionedConcurrencyConfigNotFoundException for service response error code
	// "ProvisionedConcurrencyConfigNotFoundException".
	//
	// The specified configuration does not exist.
	ErrCodeProvisionedConcurrencyConfigNotFoundException = "ProvisionedConcurrencyConfigNotFoundException"

	// ErrCodeRequestTooLargeException for service response error code
	// "RequestTooLargeException".
	//
	// The request payload exceeded the Invoke request body JSON input limit. For
	// more information, see Limits (https://docs.aws.amazon.com/lambda/latest/dg/limits.html).
	ErrCodeRequestTooLargeException = "RequestTooLargeException"

	// ErrCodeResourceConflictException for service response error code
	// "ResourceConflictException".
	//
	// The resource already exists, or another operation is in progress.
	ErrCodeResourceConflictException = "ResourceConflictException"

	// ErrCodeResourceInUseException for service response error code
	// "ResourceInUseException".
	//
	// The operation conflicts with the resource's availability. For example, you
	// attempted to update an EventSource Mapping in CREATING, or tried to delete
	// a EventSource mapping currently in the UPDATING state.
	ErrCodeResourceInUseException = "ResourceInUseException"

	// ErrCodeResourceNotFoundException for service response error code
	// "ResourceNotFoundException".
	//
	// The resource specified in the request does not exist.
	ErrCodeResourceNotFoundException = "ResourceNotFoundException"

	// ErrCodeResourceNotReadyException for service response error code
	// "ResourceNotReadyException".
	//
	// The function is inactive and its VPC connection is no longer available. Wait
	// for the VPC connection to reestablish and try again.
	ErrCodeResourceNotReadyException = "ResourceNotReadyException"

	// ErrCodeServiceException for service response error code
	// "ServiceException".
	//
	// The AWS Lambda service encountered an internal error.
	ErrCodeServiceException = "ServiceException"

	// ErrCodeSubnetIPAddressLimitReachedException for service response error code
	// "SubnetIPAddressLimitReachedException".
	//
	// AWS Lambda was not able to set up VPC access for the Lambda function because
	// one or more configured subnets has no available IP addresses.
	ErrCodeSubnetIPAddressLimitReachedException = "SubnetIPAddressLimitReachedException"

	// ErrCodeTooManyRequestsException for service response error code
	// "TooManyRequestsException".
	//
	// The request throughput limit was exceeded.
	ErrCodeTooManyRequestsException = "TooManyRequestsException"

	// ErrCodeUnsupportedMediaTypeException for service response error code
	// "UnsupportedMediaTypeException".
	//
	// The content type of the Invoke request body is not JSON.
	ErrCodeUnsupportedMediaTypeException = "UnsupportedMediaTypeException"
)

var exceptionFromCode = map[string]func(protocol.ResponseMetadata) error{
	"CodeStorageExceededException":                  newErrorCodeStorageExceededException,
	"EC2AccessDeniedException":                      newErrorEC2AccessDeniedException,
	"EC2ThrottledException":                         newErrorEC2ThrottledException,
	"EC2UnexpectedException":                        newErrorEC2UnexpectedException,
	"EFSIOException":                                newErrorEFSIOException,
	"EFSMountConnectivityException":                 newErrorEFSMountConnectivityException,
	"EFSMountFailureException":                      newErrorEFSMountFailureException,
	"EFSMountTimeoutException":                      newErrorEFSMountTimeoutException,
	"ENILimitReachedException":                      newErrorENILimitReachedException,
	"InvalidParameterValueException":                newErrorInvalidParameterValueException,
	"InvalidRequestContentException":                newErrorInvalidRequestContentException,
	"InvalidRuntimeException":                       newErrorInvalidRuntimeException,
	"InvalidSecurityGroupIDException":               newErrorInvalidSecurityGroupIDException,
	"InvalidSubnetIDException":                      newErrorInvalidSubnetIDException,
	"InvalidZipFileException":                       newErrorInvalidZipFileException,
	"KMSAccessDeniedException":                      newErrorKMSAccessDeniedException,
	"KMSDisabledException":                          newErrorKMSDisabledException,
	"KMSInvalidStateException":                      newErrorKMSInvalidStateException,
	"KMSNotFoundException":                          newErrorKMSNotFoundException,
	"PolicyLengthExceededException":                 newErrorPolicyLengthExceededException,
	"PreconditionFailedException":                   newErrorPreconditionFailedException,
	"ProvisionedConcurrencyConfigNotFoundException": newErrorProvisionedConcurrencyConfigNotFoundException,
	"RequestTooLargeException":                      newErrorRequestTooLargeException,
	"ResourceConflictException":                     newErrorResourceConflictException,
	"ResourceInUseException":                        newErrorResourceInUseException,
	"ResourceNotFoundException":                     newErrorResourceNotFoundException,
	"ResourceNotReadyException":                     newErrorResourceNotReadyException,
	"ServiceException":                              newErrorServiceException,
	"SubnetIPAddressLimitReachedException":          newErrorSubnetIPAddressLimitReachedException,
	"TooManyRequestsException":                      newErrorTooManyRequestsException,
	"UnsupportedMediaTypeException":                 newErrorUnsupportedMediaTypeException,
}
