// Code generated by protoc-gen-go. DO NOT EDIT.
// source: google/bigtable/admin/v2/common.proto

package admin

import (
	fmt "fmt"
	math "math"

	proto "github.com/golang/protobuf/proto"
	timestamp "github.com/golang/protobuf/ptypes/timestamp"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

// Storage media types for persisting Bigtable data.
type StorageType int32

const (
	// The user did not specify a storage type.
	StorageType_STORAGE_TYPE_UNSPECIFIED StorageType = 0
	// Flash (SSD) storage should be used.
	StorageType_SSD StorageType = 1
	// Magnetic drive (HDD) storage should be used.
	StorageType_HDD StorageType = 2
)

var StorageType_name = map[int32]string{
	0: "STORAGE_TYPE_UNSPECIFIED",
	1: "SSD",
	2: "HDD",
}

var StorageType_value = map[string]int32{
	"STORAGE_TYPE_UNSPECIFIED": 0,
	"SSD":                      1,
	"HDD":                      2,
}

func (x StorageType) String() string {
	return proto.EnumName(StorageType_name, int32(x))
}

func (StorageType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_79ab584e3c858108, []int{0}
}

// Encapsulates progress related information for a Cloud Bigtable long
// running operation.
type OperationProgress struct {
	// Percent completion of the operation.
	// Values are between 0 and 100 inclusive.
	ProgressPercent int32 `protobuf:"varint,1,opt,name=progress_percent,json=progressPercent,proto3" json:"progress_percent,omitempty"`
	// Time the request was received.
	StartTime *timestamp.Timestamp `protobuf:"bytes,2,opt,name=start_time,json=startTime,proto3" json:"start_time,omitempty"`
	// If set, the time at which this operation failed or was completed
	// successfully.
	EndTime              *timestamp.Timestamp `protobuf:"bytes,3,opt,name=end_time,json=endTime,proto3" json:"end_time,omitempty"`
	XXX_NoUnkeyedLiteral struct{}             `json:"-"`
	XXX_unrecognized     []byte               `json:"-"`
	XXX_sizecache        int32                `json:"-"`
}

func (m *OperationProgress) Reset()         { *m = OperationProgress{} }
func (m *OperationProgress) String() string { return proto.CompactTextString(m) }
func (*OperationProgress) ProtoMessage()    {}
func (*OperationProgress) Descriptor() ([]byte, []int) {
	return fileDescriptor_79ab584e3c858108, []int{0}
}

func (m *OperationProgress) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_OperationProgress.Unmarshal(m, b)
}
func (m *OperationProgress) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_OperationProgress.Marshal(b, m, deterministic)
}
func (m *OperationProgress) XXX_Merge(src proto.Message) {
	xxx_messageInfo_OperationProgress.Merge(m, src)
}
func (m *OperationProgress) XXX_Size() int {
	return xxx_messageInfo_OperationProgress.Size(m)
}
func (m *OperationProgress) XXX_DiscardUnknown() {
	xxx_messageInfo_OperationProgress.DiscardUnknown(m)
}

var xxx_messageInfo_OperationProgress proto.InternalMessageInfo

func (m *OperationProgress) GetProgressPercent() int32 {
	if m != nil {
		return m.ProgressPercent
	}
	return 0
}

func (m *OperationProgress) GetStartTime() *timestamp.Timestamp {
	if m != nil {
		return m.StartTime
	}
	return nil
}

func (m *OperationProgress) GetEndTime() *timestamp.Timestamp {
	if m != nil {
		return m.EndTime
	}
	return nil
}

func init() {
	proto.RegisterEnum("google.bigtable.admin.v2.StorageType", StorageType_name, StorageType_value)
	proto.RegisterType((*OperationProgress)(nil), "google.bigtable.admin.v2.OperationProgress")
}

func init() {
	proto.RegisterFile("google/bigtable/admin/v2/common.proto", fileDescriptor_79ab584e3c858108)
}

var fileDescriptor_79ab584e3c858108 = []byte{
	// 345 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0x84, 0x91, 0x41, 0x4b, 0xfb, 0x30,
	0x18, 0xc6, 0xff, 0xdd, 0xf8, 0x3b, 0xcd, 0x0e, 0xd6, 0x9e, 0xca, 0x18, 0x3a, 0x04, 0x61, 0x7a,
	0x48, 0xa1, 0xe2, 0x41, 0x64, 0x87, 0x6d, 0xad, 0x73, 0x17, 0x57, 0xd6, 0x3a, 0x50, 0x0a, 0x25,
	0x5d, 0x63, 0x28, 0xb4, 0x49, 0x48, 0xb3, 0x81, 0x5f, 0xc9, 0x83, 0xf8, 0x39, 0xfc, 0x54, 0xd2,
	0xb4, 0x39, 0x89, 0x78, 0x7b, 0xdf, 0x37, 0xbf, 0xe7, 0x7d, 0x1e, 0xde, 0x80, 0x0b, 0xc2, 0x18,
	0x29, 0xb0, 0x93, 0xe6, 0x44, 0xa2, 0xb4, 0xc0, 0x0e, 0xca, 0xca, 0x9c, 0x3a, 0x7b, 0xd7, 0xd9,
	0xb2, 0xb2, 0x64, 0x14, 0x72, 0xc1, 0x24, 0xb3, 0xec, 0x06, 0x83, 0x1a, 0x83, 0x0a, 0x83, 0x7b,
	0x77, 0x70, 0xd6, 0x2e, 0x50, 0x5c, 0xba, 0x7b, 0x75, 0x64, 0x5e, 0xe2, 0x4a, 0xa2, 0x92, 0x37,
	0xd2, 0xf3, 0x4f, 0x03, 0x9c, 0xac, 0x38, 0x16, 0x48, 0xe6, 0x8c, 0x06, 0x82, 0x11, 0x81, 0xab,
	0xca, 0xba, 0x04, 0x26, 0x6f, 0xeb, 0x84, 0x63, 0xb1, 0xc5, 0x54, 0xda, 0xc6, 0xc8, 0x18, 0xff,
	0x5f, 0x1f, 0xeb, 0x79, 0xd0, 0x8c, 0xad, 0x5b, 0x00, 0x2a, 0x89, 0x84, 0x4c, 0xea, 0xcd, 0x76,
	0x67, 0x64, 0x8c, 0xfb, 0xee, 0x00, 0xb6, 0x81, 0xb4, 0x2d, 0x8c, 0xb4, 0xed, 0xfa, 0x48, 0xd1,
	0x75, 0x6f, 0xdd, 0x80, 0x43, 0x4c, 0xb3, 0x46, 0xd8, 0xfd, 0x53, 0xd8, 0xc3, 0x34, 0xab, 0xbb,
	0xab, 0x09, 0xe8, 0x87, 0x92, 0x09, 0x44, 0x70, 0xf4, 0xc6, 0xb1, 0x35, 0x04, 0x76, 0x18, 0xad,
	0xd6, 0xd3, 0x85, 0x9f, 0x44, 0xcf, 0x81, 0x9f, 0x3c, 0x3d, 0x86, 0x81, 0x3f, 0x5f, 0xde, 0x2f,
	0x7d, 0xcf, 0xfc, 0x67, 0xf5, 0x40, 0x37, 0x0c, 0x3d, 0xd3, 0xa8, 0x8b, 0x07, 0xcf, 0x33, 0x3b,
	0xb3, 0x0f, 0x03, 0x0c, 0xb7, 0xac, 0x84, 0xbf, 0xdd, 0x6c, 0xd6, 0x9f, 0xab, 0xdb, 0x06, 0x75,
	0x84, 0xc0, 0x78, 0x99, 0xb4, 0x20, 0x61, 0x05, 0xa2, 0x04, 0x32, 0x41, 0x1c, 0x82, 0xa9, 0x0a,
	0xe8, 0x34, 0x4f, 0x88, 0xe7, 0xd5, 0xcf, 0x2f, 0xba, 0x53, 0xc5, 0x7b, 0xe7, 0x74, 0xd1, 0xe8,
	0xe7, 0x05, 0xdb, 0x65, 0x70, 0xa6, 0xed, 0xa6, 0xca, 0x6e, 0xe3, 0x7e, 0x69, 0x20, 0x56, 0x40,
	0xac, 0x81, 0x58, 0x01, 0xf1, 0xc6, 0x4d, 0x0f, 0x94, 0xd7, 0xf5, 0x77, 0x00, 0x00, 0x00, 0xff,
	0xff, 0xbf, 0xc5, 0x68, 0xd4, 0x0d, 0x02, 0x00, 0x00,
}
